--- u-boot-2011.06_original/include/cnc1800l_demux.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc1800l_demux.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,200 @@
+#ifndef __CNC1800L_DEMUX_H__
+#define __CNC1800L_DEMUX_H__
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+#define CSDEMUX_INVALID_HANDLE     -1
+
+typedef void *CSDEMUX_HANDLE;
+
+typedef enum
+{
+	DEMUX_SUCCEED = 0,
+	DEMUX_FAILED = -1
+} CSDEMUX_RESULT;
+
+typedef enum
+{
+	DEMUX_DISABLE = 0,
+	DEMUX_ENABLE = 1,
+} CSDEMUX_STATUS;
+
+typedef enum
+{
+	DEMUX_CHL_UNDEF = -1,
+	DEMUX_CHL_ID0 = 0,
+	DEMUX_CHL_ID1,
+	DEMUX_CHL_NUM
+} CSDEMUX_CHL_ID;
+
+typedef enum
+{
+	DEMUX_PIDFT_UNDEF = -1,
+	DEMUX_PIDFT_ID0 = 0,
+	DEMUX_PIDFT_ID1,
+	DEMUX_PIDFT_ID2,
+	DEMUX_PIDFT_ID3,
+	DEMUX_PIDFT_ID4,
+	DEMUX_PIDFT_ID5,
+	DEMUX_PIDFT_ID6,
+	DEMUX_PIDFT_ID7,
+	DEMUX_PIDFT_ID8,
+	DEMUX_PIDFT_ID9,
+	DEMUX_PIDFT_ID10,
+	DEMUX_PIDFT_ID11,
+	DEMUX_PIDFT_ID12,
+	DEMUX_PIDFT_ID13,
+	DEMUX_PIDFT_ID14,
+	DEMUX_PIDFT_ID15,
+	DEMUX_PIDFT_ID16,
+	DEMUX_PIDFT_ID17,
+	DEMUX_PIDFT_ID18,
+	DEMUX_PIDFT_ID19,
+	DEMUX_PIDFT_ID20,
+	DEMUX_PIDFT_ID21,
+	DEMUX_PIDFT_ID22,
+	DEMUX_PIDFT_ID23,
+	DEMUX_PIDFT_ID24,
+	DEMUX_PIDFT_ID25,
+	DEMUX_PIDFT_ID26,
+	DEMUX_PIDFT_ID27,
+	DEMUX_PIDFT_ID28,
+	DEMUX_PIDFT_ID29,
+	DEMUX_PIDFT_ID30,
+	DEMUX_PIDFT_ID31,
+	DEMUX_PIDFT_ID32,
+	DEMUX_PIDFT_ID33,
+	DEMUX_PIDFT_ID34,
+	DEMUX_PIDFT_ID35,
+	DEMUX_PIDFT_ID36,
+	DEMUX_PIDFT_ID37,
+	DEMUX_PIDFT_ID38,
+	DEMUX_PIDFT_ID39,
+	DEMUX_PIDFT_ID40,
+	DEMUX_PIDFT_ID41,
+	DEMUX_PIDFT_ID42,
+	DEMUX_PIDFT_ID43,
+	DEMUX_PIDFT_ID44,
+	DEMUX_PIDFT_ID45,
+	DEMUX_PIDFT_ID46,
+	DEMUX_PIDFT_ID47,
+	DEMUX_PIDFT_ID48,
+	DEMUX_PIDFT_ID49,
+	DEMUX_PIDFT_ID50,
+	DEMUX_PIDFT_ID51,
+	DEMUX_PIDFT_ID52,
+	DEMUX_PIDFT_ID53,
+	DEMUX_PIDFT_ID54,
+	DEMUX_PIDFT_ID55,
+	DEMUX_PIDFT_ID56,
+	DEMUX_PIDFT_ID57,
+	DEMUX_PIDFT_ID58,
+	DEMUX_PIDFT_ID59,
+	DEMUX_PIDFT_ID60,
+	DEMUX_PIDFT_ID61,
+	DEMUX_PIDFT_ID62,
+	DEMUX_PIDFT_ID63,
+	DEMUX_PIDFT_NUM
+} CSDEMUX_PIDFT_ID;
+
+typedef enum
+{
+	DEMUX_FILTER_UNDEF = -1,
+	DEMUX_FILTER_ID0 = 0,
+	DEMUX_FILTER_ID1,
+	DEMUX_FILTER_ID2,
+	DEMUX_FILTER_ID3,
+	DEMUX_FILTER_ID4,
+	DEMUX_FILTER_ID5,
+	DEMUX_FILTER_ID6,
+	DEMUX_FILTER_ID7,
+	DEMUX_FILTER_ID8,
+	DEMUX_FILTER_ID9,
+	DEMUX_FILTER_ID10,
+	DEMUX_FILTER_ID11,
+	DEMUX_FILTER_ID12,
+	DEMUX_FILTER_ID13,
+	DEMUX_FILTER_ID14,
+	DEMUX_FILTER_ID15,
+	DEMUX_FILTER_ID16,
+	DEMUX_FILTER_ID17,
+	DEMUX_FILTER_ID18,
+	DEMUX_FILTER_ID19,
+	DEMUX_FILTER_ID20,
+	DEMUX_FILTER_ID21,
+	DEMUX_FILTER_ID22,
+	DEMUX_FILTER_ID23,
+	DEMUX_FILTER_ID24,
+	DEMUX_FILTER_ID25,
+	DEMUX_FILTER_ID26,
+	DEMUX_FILTER_ID27,
+	DEMUX_FILTER_ID28,
+	DEMUX_FILTER_ID29,
+	DEMUX_FILTER_ID30,
+	DEMUX_FILTER_ID31,
+	DEMUX_FILTER_NUM
+} CSDEMUX_FILTER_ID;
+
+typedef enum
+{
+	DEMUX_FILTER_TYPE_UNDEF = -1,
+	DEMUX_FILTER_TYPE_SEC = 0,
+	DEMUX_FILTER_TYPE_TS,
+	DEMUX_FILTER_TYPE_PES,
+	DEMUX_FILTER_TYPE_ES
+} CSDEMUX_FILTER_TYPE;
+
+typedef enum
+{
+	DEMUX_INPUT_MOD_TUNER = 0,
+	DEMUX_INPUT_MOD_DMA,
+	DEMUX_INPUT_MOD_DIRECT
+} CSDEMUX_INPUT_MOD;
+
+typedef enum
+{
+	DEMUX_TUNER_MOD_PARALLEL = 0,
+	DEMUX_TUNER_MOD_SERIAL,
+} CSDEMUX_TUNER_MOD;
+
+/*XPORT API*/
+/* common interface*/
+CSDEMUX_RESULT CSDEMUX_Init(void);
+
+/* channel interface */
+CSDEMUX_HANDLE CSDEMUX_CHL_Open(CSDEMUX_CHL_ID chl_id);
+CSDEMUX_RESULT CSDEMUX_CHL_Close(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_CHL_SetInputMode(CSDEMUX_HANDLE handle, CSDEMUX_INPUT_MOD input_mod);
+CSDEMUX_RESULT CSDEMUX_CHL_Enable(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_CHL_Disable(CSDEMUX_HANDLE handle);
+
+/*pid filter interface*/
+CSDEMUX_HANDLE CSDEMUX_PIDFT_Open(CSDEMUX_PIDFT_ID pidfilter_id);
+CSDEMUX_RESULT CSDEMUX_PIDFT_Close(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_PIDFT_SetChannel(CSDEMUX_HANDLE handle, CSDEMUX_CHL_ID chl_id);
+CSDEMUX_RESULT CSDEMUX_PIDFT_SetPID(CSDEMUX_HANDLE handle, unsigned short pid);
+CSDEMUX_RESULT CSDEMUX_PIDFT_Enable(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_PIDFT_Disable(CSDEMUX_HANDLE handle);
+
+/* Filter interface */
+CSDEMUX_HANDLE CSDEMUX_Filter_Open(CSDEMUX_FILTER_ID filter_id);
+CSDEMUX_RESULT CSDEMUX_Filter_Close(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_Filter_SetFilterType(CSDEMUX_HANDLE handle, CSDEMUX_FILTER_TYPE type);
+CSDEMUX_RESULT CSDEMUX_Filter_SetFilter(CSDEMUX_HANDLE handle, const unsigned char *const filter_ptr, const unsigned char *const mask_ptr);
+CSDEMUX_RESULT CSDEMUX_Filter_AddPID(CSDEMUX_HANDLE handle, unsigned short pid);
+CSDEMUX_RESULT CSDEMUX_Filter_ResetPID(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_Filter_ReadWait(CSDEMUX_HANDLE handle, unsigned int ms_timeout);
+CSDEMUX_RESULT CSDEMUX_Filter_CheckDataSize(CSDEMUX_HANDLE handle, unsigned int *size);
+CSDEMUX_RESULT CSDEMUX_Filter_GetSectionCount(CSDEMUX_HANDLE handle, unsigned int *count);
+CSDEMUX_RESULT CSDEMUX_Filter_ReadSectionData(CSDEMUX_HANDLE handle, unsigned char *buf, unsigned int *size);
+CSDEMUX_RESULT CSDEMUX_Filter_Enable(CSDEMUX_HANDLE handle);
+CSDEMUX_RESULT CSDEMUX_Filter_Disable(CSDEMUX_HANDLE handle);
+
+#ifdef __cplusplus
+}
+#endif
+
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/cnc1800l_spi.h u-boot-2011.06/include/cnc1800l_spi.h
--- u-boot-2011.06_original/include/cnc1800l_spi.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc1800l_spi.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,114 @@
+#ifndef __CNC1800L_SPI_H__
+#define __CNC1800L_SPI_H__
+#define SREG_BASE   	0x80150000
+
+#define rCTRLR0	    (SREG_BASE + 0x00)
+#define rCTRLR1	    (SREG_BASE + 0x04)
+#define rSSIENR	    (SREG_BASE + 0x08)
+#define rMWCR  	    (SREG_BASE + 0x0C)
+#define rSER   	    (SREG_BASE + 0x10)
+#define rBAUDR    	(SREG_BASE + 0x14)
+#define rTXFTLR 	(SREG_BASE + 0x18)
+#define rRXFTLR 	(SREG_BASE + 0x1C)
+#define rTXFLR  	(SREG_BASE + 0x20)
+#define rRXFLR  	(SREG_BASE + 0x24)
+#define rSR    		(SREG_BASE + 0x28)
+#define rIMR   		(SREG_BASE + 0x2C)
+#define rISR   		(SREG_BASE + 0x30)
+#define rRISR  		(SREG_BASE + 0x34)
+#define rTXOICR 	(SREG_BASE + 0x38)
+#define rRXOICR 	(SREG_BASE + 0x3C)
+#define rRXUICR		(SREG_BASE + 0x40)
+#define rMSTICR		(SREG_BASE + 0x44)
+#define rICR   		(SREG_BASE + 0x48)
+#define rDR    		(SREG_BASE + 0x60)
+
+#define SPI_PINMUX  (0xb211000c)
+
+#define BOOTCFG		0x80100034
+
+#define spi_write(a, v) 	(*((volatile unsigned short *)(a)) = (v))
+#define spi_read(a) 		(*((volatile unsigned short *)(a)))
+
+#define mdelay(s) 	({ int _tmp = 0; while (_tmp++ < (s)) udelay(1000); })
+#define mdelay_wheel(s)	({ int _tmp = 0; while (_tmp++ < (s)) { udelay(1000); if (!(_tmp % 100)) spin_wheel(); } })
+
+#define CMD_RDSR 	0x05
+#define CMD_WRSR 	0x01
+#define CMD_READ 	0x03
+#define CMD_WREN 	0x06
+#define CMD_PP 		0x02
+#define CMD_SE 		0x20
+#define CMD_BE 		0xd8
+#define CMD_CE 		0xc7
+#define CMD_RDID 	0x9f
+
+#define PP_SZ        256
+#define PP_TIME_US 	1500
+//#define FL_SEC_SZ 	0x1000
+//#define FL_BLK_SZ 	0x10000
+
+/****************************************************************************/
+
+//#define SPI_DEBUG
+#ifdef SPI_DEBUG
+#define SDEBUG(args...)                     \
+	do {                                    \
+		printf(args);                       \
+	} while(0)
+#else
+#define SDEBUG(args...) do { } while(0)
+#endif
+
+/****************************************************************************/
+
+typedef enum {
+	ERASE_SEC,
+	ERASE_BLK,
+	ERASE_CHIP
+} flasherase_t;
+
+typedef enum {
+	TMOD_TXRX = 0x0,
+	TMOD_TX   = 0x1,
+	TMOD_RX   = 0x2,
+	TMOD_EE   = 0x3 } TMOD_E;
+typedef enum {
+	TIMING0   = 0,
+	TIMING1   = 1,
+	TIMING2   = 2,
+	TIMING3   = 3   } TIMING_E;
+
+typedef enum {
+	BOOT_NOR  = 0,
+	BOOT_SPI  = 1,
+	BOOT_NAND = 2   } BOOT_TYPE_E;
+
+typedef struct sflash_info {
+	char	*name;
+	u32		jedec_id;
+	u16     ext_id;
+
+	unsigned sector_size;
+	u16		n_sectors;
+
+	u16		flags;
+#define	SECT_4K		0x01
+} sfinf_t;
+
+#ifndef ARRAY_SIZE
+#define ARRAY_SIZE(x)		(sizeof(x) / sizeof((x)[0]))
+#endif
+
+/**********************************************************************************/
+
+void spi__init(void);
+
+int seeprom_read(unsigned caddr, uchar *maddr, unsigned size);
+int seeprom_write(unsigned caddr, uchar *maddr, unsigned size);
+int seeprom_erase(unsigned cmd, unsigned saddr, unsigned size);
+int seeprom_probe(void);
+
+/**********************************************************************************/
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/cnc1800l_tuner.h u-boot-2011.06/include/cnc1800l_tuner.h
--- u-boot-2011.06_original/include/cnc1800l_tuner.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc1800l_tuner.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,78 @@
+
+#ifndef	_CNC1800L_TUNER_H_
+#define	_CNC1800L_TUNER_H_
+
+#include <common.h>
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef enum { 
+	TUNER_DVBS,
+	TUNER_DVBC
+} TUNER_DEV_TYPE;
+
+typedef enum {
+        TUNER_FEC_NONE = 0,
+        TUNER_FEC_1_2,
+        TUNER_FEC_2_3,
+        TUNER_FEC_3_4,
+        TUNER_FEC_4_5,
+        TUNER_FEC_5_6,
+        TUNER_FEC_6_7,
+        TUNER_FEC_7_8,
+        TUNER_FEC_8_9,
+        TUNER_FEC_AUTO
+} CSTUNER_FEC_RATES;
+
+typedef enum {
+	TUNER_STATUS_UNLOCKED = 0,
+	TUNER_STATUS_FE_LOCKED,
+	TUNER_STATUS_PLL_LOCKED,
+	TUNER_STATUS_SCANNING,
+	TUNER_STATUS_NOT_FOUND
+} TUNER_STATUS_E;
+
+typedef enum {
+	INVERSION_NORMAL = 0,
+	INVERSION_INVERTED,
+	INVERSION_AUTO
+} TUNER_SPECTRAL_INVERSION_E;
+
+typedef enum {
+	QAM_4 = 0,
+	QAM_16,
+	QAM_32,
+	QAM_64,
+	QAM_128,
+	QAM_256,
+	QAM_AUTO
+} TUNER_QAM_MODULATION_E;
+
+typedef struct {
+	unsigned int frequency;		/* MHz */
+	unsigned int symbol_rate;	/* MS/s */
+
+	/* dvbc */
+	TUNER_QAM_MODULATION_E modulation;
+	TUNER_SPECTRAL_INVERSION_E inversion;
+
+	/* dvbs */
+	CSTUNER_FEC_RATES FECRates;
+	unsigned int  LnbFrequency;     /* MHz */
+	unsigned int  Polarization;     /* 'V' FALSE 'H' TRUE */
+
+} TUNER_PARAMS_S;
+
+int	CSTUNER_Init(void);
+int	CSTUNER_Open(TUNER_DEV_TYPE type);
+int	CSTUNER_Close(void);
+int	CSTUNER_SetFrequency(TUNER_PARAMS_S *params);
+int	CSTUNER_GetTunerInfo(TUNER_PARAMS_S *params);
+int	CSTUNER_ReadStatus(TUNER_STATUS_E *status);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif	/*	_CS_TUNER_LG_H_	*/
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/cnc1900_audio_reg.h u-boot-2011.06/include/cnc1900_audio_reg.h
--- u-boot-2011.06_original/include/cnc1900_audio_reg.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc1900_audio_reg.h	2015-08-20 19:25:54.678159000 +0800
@@ -0,0 +1,148 @@
+#ifndef __CSM1800_AUDIO_REGISTERS_H__
+#define __CSM1800_AUDIO_REGISTERS_H__
+
+#define CSM1300_REG_BASE_ADDR 0xb1200000
+
+/* ----------------- Common Register ------------------ */
+#define CSM1300_AUD_STC             (CSM1300_REG_BASE_ADDR + 0x0000)
+#define CSM1300_AUD_HISTC           (CSM1300_REG_BASE_ADDR + 0x0004)
+#define CSM1300_AUD_MAILBOX0        (CSM1300_REG_BASE_ADDR + 0x0100)
+#define CSM1300_AUD_MAILBOX1        (CSM1300_REG_BASE_ADDR + 0x0104)
+#define CSM1300_AUD_MAILBOX2        (CSM1300_REG_BASE_ADDR + 0x0108)
+#define CSM1300_AUD_MAILBOX3        (CSM1300_REG_BASE_ADDR + 0x010c)
+#define CSM1300_AUD_MAILBOX4        (CSM1300_REG_BASE_ADDR + 0x0110)
+#define CSM1300_AUD_MAILBOX5        (CSM1300_REG_BASE_ADDR + 0x0114)
+#define CSM1300_AUD2VID_MAILBOX0    (CSM1300_REG_BASE_ADDR + 0x0118)
+#define CSM1300_AUD2VID_MAILBOX1    (CSM1300_REG_BASE_ADDR + 0x0120)
+#if 1
+#define CSM1300_VID2AUD_MAILBOX0    (CSM1300_REG_BASE_ADDR + 0x011c)
+#define CSM1300_VID2AUD_MAILBOX1    (CSM1300_REG_BASE_ADDR + 0x0124)
+#endif
+#define CSM1300_AUD_INT             (CSM1300_REG_BASE_ADDR + 0x0200)
+#define CSM1300_DSP_INT_SRC         (CSM1300_REG_BASE_ADDR + 0x0204)
+#define CSM1300_DSP_INT_MASK        (CSM1300_REG_BASE_ADDR + 0x0208)
+#define CSM1300_DSP_INT_INPUT_BIT   0x01
+#define CSM1300_DSP_INT_SFT_BIT     0x02
+#define CSM1300_DSP_INT_UART_BIT    0x04
+#define CSM1300_DSP_INT_TIMER0_BIT  0x08
+#define CSM1300_DSP_INT_TIMER1_BIT  0x10
+#define CSM1300_AUD_DDR_IO          (CSM1300_REG_BASE_ADDR + 0x0504)
+
+/* ------------------ I2s input ---------------------- */
+#define CSM1300_AUDIO_INPUT_LEVEL   (CSM1300_REG_BASE_ADDR + 0x0300)
+#define CSM1300_AUDIO_INPUT_CTRL    (CSM1300_REG_BASE_ADDR + 0x0304)
+#define CSM1300_AUDIO_INPUT_CTRL_ENABLE_BIT     0x1
+#define CSM1300_AUDIO_INPUT_CTRL_INVERT_WS_BIT  0x10
+#define CSM1300_AUDIO_INPUT_CTRL_INVERT_SCK_BIT 0x100
+#define CSM1300_AUDIO_INPUT_CTRL_SHIFT_CNT_BIT  0x1f0000
+
+#define CSM1300_AUDIO_INPUT_CNT     (CSM1300_REG_BASE_ADDR + 0x0308)
+#define CSM1300_AUDIO_INPUT_SAMPLE  (CSM1300_REG_BASE_ADDR + 0x030c)
+#define CSM1300_AUDIO_INPUT_RATE    (CSM1300_REG_BASE_ADDR + 0x0310)
+#if !ENA_DMA_IFIFO
+#define CSM1300_AUD_PTS0RP          (CSM1300_REG_BASE_ADDR + 0x0400)
+#define CSM1300_AUD_PTS0WP          (CSM1300_REG_BASE_ADDR + 0x0404)
+#define CSM1300_AUD_PTS0UP          (CSM1300_REG_BASE_ADDR + 0x0408)
+#define CSM1300_AUD_PTS0LOW         (CSM1300_REG_BASE_ADDR + 0x040c)
+#define CSM1300_AUD_PTS1RP          (CSM1300_REG_BASE_ADDR + 0x0410)
+#define CSM1300_AUD_PTS1WP          (CSM1300_REG_BASE_ADDR + 0x0414)
+#define CSM1300_AUD_PTS1UP          (CSM1300_REG_BASE_ADDR + 0x0418)
+#define CSM1300_AUD_PTS1LOW         (CSM1300_REG_BASE_ADDR + 0x041c)
+#endif
+#define CSM1300_AUD_PTS_BITWIDTH    (0x7FFFFFF8)
+#define CSM1300_AUD_PTS_TOGGLEBIT   (0x80000000)
+
+
+
+/* ------------------ INPUT FIFO --------------------- */
+#if !ENA_DMA_IFIFO
+#define CSM1300_AUD_CAB0RP          (CSM1300_REG_BASE_ADDR + 0x4100)
+#define CSM1300_AUD_CAB0WP          (CSM1300_REG_BASE_ADDR + 0x4104)
+#define CSM1300_AUD_CAB0UP          (CSM1300_REG_BASE_ADDR + 0x4108)
+#define CSM1300_AUD_CAB0LOW         (CSM1300_REG_BASE_ADDR + 0x410c)
+#define CSM1300_AUD_IFIFO0          (CSM1300_REG_BASE_ADDR + 0x4110)
+#define CSM1300_AUD_CAB1RP          (CSM1300_REG_BASE_ADDR + 0x4200)
+#define CSM1300_AUD_CAB1WP          (CSM1300_REG_BASE_ADDR + 0x4204)
+#define CSM1300_AUD_CAB1UP          (CSM1300_REG_BASE_ADDR + 0x4208)
+#define CSM1300_AUD_CAB1LOW         (CSM1300_REG_BASE_ADDR + 0x420c)
+#define CSM1300_AUD_CAB_BITWIDTH    (0x0FFFFFF8)
+#define CSM1300_AUD_CAB_TOGGLEBIT   (0x10000000)
+
+#define CSM1300_AUD_IFIFO1          (CSM1300_REG_BASE_ADDR + 0x4210)
+#define CSM1300_AUD_IFIFO_CTRL      (CSM1300_REG_BASE_ADDR + 0x4000)
+#define CSM1300_AUD_IFIFO_CTRL_ENABLE0 0x1
+#define CSM1300_AUD_IFIFO_CTRL_ENABLE1 0x2
+#define CSM1300_AUD_IFIFO_CTRL_CLEAR0  0x4 // disable first, then clear
+#define CSM1300_AUD_IFIFO_CTRL_CLEAR1  0x8
+#define CSM1300_AUD_IFIFOCNT        (CSM1300_REG_BASE_ADDR + 0x4004)
+                                    // high 16 bits for fifo1,
+                                    // low 16 bits for fifo0.
+#else
+
+
+//#define CSM1300_AUDIN_RPWP_INDEX     (CSM1300_REG_BASE_ADDR + 0x4104) // CSM1300_AUD_CAB0WP          //(CSM1300_REG_BASE_ADDR + 0x410c) // CSM1300_AUD_CAB0LOW
+//#define CSM1300_AUDIN_LOWUP_INDEX    (CSM1300_REG_BASE_ADDR + 0x4108) // CSM1300_AUD_CAB0UP
+#define CSM1300_AUDIN_CAB_BITWIDTH    (0x7FFFFFFC)
+#define CSM1300_AUDIN_CAB_TOGGLEBIT   (0x80000000)
+#ifdef SUPPORT_VOIP
+#define CSM1300_AUDOUT_CAB_BITWIDTH   (0x7FFFFFFF)
+#define CSM1300_AUDOUT_CAB_TOGGLEBIT  (0x80000000)
+#endif
+#define CSM1300_FW_VERSION_REG		 (CSM1300_REG_BASE_ADDR + 0x410c) // CSM1300_AUD_CAB0LOW         
+#endif
+
+/* ------------------ AUDIO I2S ----------------------- */
+#define CSM1300_AUD_I2S_SHIFTCNT    (CSM1300_REG_BASE_ADDR + 0x1000)
+#define CSM1300_AUD_I2S_CNTL        (CSM1300_REG_BASE_ADDR + 0x1004)
+#define CSM1300_AUD_I2S_RP0         (CSM1300_REG_BASE_ADDR + 0x1100)
+#define CSM1300_AUD_I2S_WP0         (CSM1300_REG_BASE_ADDR + 0x1104)
+#define CSM1300_AUD_I2S_UP0         (CSM1300_REG_BASE_ADDR + 0x1108)
+#define CSM1300_AUD_I2S_LOW0        (CSM1300_REG_BASE_ADDR + 0x110c)
+#define CSM1300_AUD_I2S_SCAL0       (CSM1300_REG_BASE_ADDR + 0x1110)
+#define CSM1300_AUD_I2S_RP1         (CSM1300_REG_BASE_ADDR + 0x1114)
+#define CSM1300_AUD_I2S_WP1         (CSM1300_REG_BASE_ADDR + 0x1118)
+#define CSM1300_AUD_I2S_UP1         (CSM1300_REG_BASE_ADDR + 0x111c)
+#define CSM1300_AUD_I2S_LOW1        (CSM1300_REG_BASE_ADDR + 0x1120)
+#define CSM1300_AUD_I2S_SCAL1       (CSM1300_REG_BASE_ADDR + 0x1124)
+#define CSM1300_AUD_I2S_BITWIDTH    0x7FFFFFF8
+#define CSM1300_AUD_I2S_TOGGLEBIT   0x80000000
+
+// CSM1300_AUD_I2Sx_yyy = CSM1300_AUD_I2S_yyy + 0x100*x. x = [0, 1, 2, 3]
+
+/* ------------------ AUDIO I2S ----------------------- */
+#define CSM1300_AUD_SPDIF_CNTL      (CSM1300_REG_BASE_ADDR + 0x2000)
+#define CSM1300_AUD_SPDIF_RP0       (CSM1300_REG_BASE_ADDR + 0x2100)
+#define CSM1300_AUD_SPDIF_WP0       (CSM1300_REG_BASE_ADDR + 0x2104)
+#define CSM1300_AUD_SPDIF_UP0       (CSM1300_REG_BASE_ADDR + 0x2108)
+#define CSM1300_AUD_SPDIF_LOW0      (CSM1300_REG_BASE_ADDR + 0x210c)
+#define CSM1300_AUD_SPDIF_SCAL0     (CSM1300_REG_BASE_ADDR + 0x2110)
+#define CSM1300_AUD_SPDIF_RP1       (CSM1300_REG_BASE_ADDR + 0x2114)
+#define CSM1300_AUD_SPDIF_WP1       (CSM1300_REG_BASE_ADDR + 0x2118)
+#define CSM1300_AUD_SPDIF_UP1       (CSM1300_REG_BASE_ADDR + 0x211c)
+#define CSM1300_AUD_SPDIF_LOW1      (CSM1300_REG_BASE_ADDR + 0x2120)
+#define CSM1300_AUD_SPDIF_SCAL1     (CSM1300_REG_BASE_ADDR + 0x2124)
+#define CSM1300_AUD_SPDIF_VERSION   (CSM1300_REG_BASE_ADDR + 0x2200)
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS1  (CSM1300_REG_BASE_ADDR + 0x2204)
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS12 (CSM1300_REG_BASE_ADDR + 0x2208)
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS2  (CSM1300_REG_BASE_ADDR + 0x220c)
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS3  (CSM1300_REG_BASE_ADDR + 0x2210)  // Audio bit rate
+#define CSM1300_AUD_SPDIF_VALID           (CSM1300_REG_BASE_ADDR + 0x2238)
+#define CSM1300_AUD_SPDIF_FIFO_STATUS     (CSM1300_REG_BASE_ADDR + 0x223c)
+#define CSM1300_AUD_SPDIF_BITWIDTH    0x7FFFFFF8
+#define CSM1300_AUD_SPDIF_TOGGLEBIT   0x80000000
+
+
+/* not used spdif regs */
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS4 (CSM1300_REG_BASE_ADDR + 0x2214)
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS5 (CSM1300_REG_BASE_ADDR + 0x2218)
+#define CSM1300_AUD_SPDIF_CHANNELSTATUS6 (CSM1300_REG_BASE_ADDR + 0x221C)
+#define CSM1300_AUD_SPDIF_USERDATA1      (CSM1300_REG_BASE_ADDR + 0x2220)
+#define CSM1300_AUD_SPDIF_USERDATA2      (CSM1300_REG_BASE_ADDR + 0x2224)
+#define CSM1300_AUD_SPDIF_USERDATA3      (CSM1300_REG_BASE_ADDR + 0x2228)
+#define CSM1300_AUD_SPDIF_USERDATA4      (CSM1300_REG_BASE_ADDR + 0x222C)
+#define CSM1300_AUD_SPDIF_USERDATA5      (CSM1300_REG_BASE_ADDR + 0x2230)
+#define CSM1300_AUD_SPDIF_USERDATA6      (CSM1300_REG_BASE_ADDR + 0x2234)
+
+
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/cnc1900_clock_reg.h u-boot-2011.06/include/cnc1900_clock_reg.h
--- u-boot-2011.06_original/include/cnc1900_clock_reg.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc1900_clock_reg.h	2015-08-20 19:25:54.678159000 +0800
@@ -0,0 +1,79 @@
+#ifndef _CNC1900_CLOCK_REG_H_
+#define _CNC1900_CLOCK_REG_H_
+
+#ifdef __cplusplus
+extern "C"{
+#endif
+typedef enum _CLOCK_REG_BANK_
+{
+  CNC1900_ID_SCS                    =0xB2100000,
+
+  CLOCK_ID_BASE                     =(CNC1900_ID_SCS+(0<<2)),
+  CLOCK_PLL_BASE                    =(CNC1900_ID_SCS+(0x40<<2)),
+  CLOCK_MUX_BASE                    =(CNC1900_ID_SCS+(0x50<<2)),
+  CLOCK_RESET_BASE                  =(CNC1900_ID_SCS+(0x80<<2)),
+  PLL_PARA_BASE                     =(CNC1900_ID_SCS+(0xC0<<2)),
+  VDAC_BASE                         =(CNC1900_ID_SCS+(0xD4<<2)),
+  CPU_PWR_BASE                      =(CNC1900_ID_SCS+(0xD8<<2)),
+
+  CLOCK_ID_LO                       =(CLOCK_ID_BASE+(0<<2)),
+  CLOCK_ID_HI                       =(CLOCK_ID_BASE+(1<<2)),
+
+  //B2100100
+  CLOCK_PLL_AVS_DIV                 =(CLOCK_PLL_BASE+(1<<2)),       
+  CLOCK_AUD_DIV                     =(CLOCK_PLL_BASE+(6<<2)),
+  CLOCK_CLK_GEN_DIV                 =(CLOCK_PLL_BASE+(8<<2)),
+
+  //B2100140
+  CLOCK_PLL_CLK_EN                  =(CLOCK_MUX_BASE+(0<<2)),
+  CLK_SRC_SEL                       =(CLOCK_MUX_BASE+(1<<2)),
+  CLOCK_TVE_DIV_N		            =(CLOCK_MUX_BASE+(2<<2)),
+
+  //B2100200
+  CLOCK_SOFT_RESET                  =(CLOCK_RESET_BASE+(0<<2)),
+  CLOCK_CLK_RESET                   =(CLOCK_RESET_BASE+(1<<2)),
+  CLOCK_PLL_SLEEP_N                 =(CLOCK_RESET_BASE+(3<<2)),
+  CLOCK_HDMI_CLK_SEL                =(CLOCK_RESET_BASE+(6<<2)),
+  SB_CTRL                           =(CLOCK_RESET_BASE+(7<<2)),
+  SB_STATUS                         =(CLOCK_RESET_BASE+(8<<2)),
+
+  //B2100300
+  CPUCLK_ST_INT                     =(PLL_PARA_BASE+ (5<<2)),
+  PLL_CPU_DIV                       =(PLL_PARA_BASE+ (6<<2)),
+  PLL_TVE_PARA_Q                    =(PLL_PARA_BASE+ (7<<2)),
+  PLL_TVE_PARA_F                    =(PLL_PARA_BASE+ (8<<2)),
+  PLL_AUD_PARA_Q                    =(PLL_PARA_BASE+ (9<<2)),
+  PLL_AUD_PARA_F                    =(PLL_PARA_BASE+ (0x0A<<2)),
+  PLL_SYS_PARA_Q                    =(PLL_PARA_BASE+ (0x0B<<2)),
+  PLL_SYS_PARA_F                    =(PLL_PARA_BASE+ (0x0C<<2)),
+  PLL_DDR_PARA_Q                    =(PLL_PARA_BASE+ (0x0D<<2)),
+  PLL_DDR_PARA_F                    =(PLL_PARA_BASE+ (0x0E<<2)),
+  PLL_NEWDIV                        =(PLL_PARA_BASE+ (0x0F<<2)),
+  PLL_CODA_PARA_Q                   =(PLL_PARA_BASE+ (0x11<<2)),
+  PLL_CODA_PARA_F                   =(PLL_PARA_BASE+ (0x12<<2)),
+  CPU_PWR_MODE                   	=(PLL_PARA_BASE+ (0x20<<2)),
+  PLL_CLK_EN                   		=(PLL_PARA_BASE+ (0x50<<2)),
+
+  //B2100350
+  VDAC0_CTRL                        =(VDAC_BASE    + (0<<2)),
+  VDAC1_CTRL                        =(VDAC_BASE    + (1<<2)),
+  VDAC_CABLE_DET                    =(VDAC_BASE    + (2<<2)),
+
+  //B2100360
+  CPU_POWER_STATUS                  =(CPU_PWR_BASE + (0<<2)),
+  CPU_POWER_CTRL                    =(CPU_PWR_BASE + (1<<2)),
+  CPU_RST_CTRL                      =(CPU_PWR_BASE + (2<<2)),
+  CPU_SCU_EV_ABORT                  =(CPU_PWR_BASE + (3<<2)),
+  CPU_SCU_CHRC_CNT                  =(CPU_PWR_BASE + (4<<2)),
+  CPU_POWER_MODE                    =(CPU_PWR_BASE + (8<<2)),
+  USB_CTRL                          =(CPU_PWR_BASE + (0x0C<<2)),
+  STC_CTRL                          =(CPU_PWR_BASE + (0x10<<2)),
+
+  CLOCK_REG_SIZE = 0x1000,
+}CLOCK_REG_BANK;
+
+#ifdef __cplusplus
+}
+#endif
+#endif
+
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/cnc1900_spi.h u-boot-2011.06/include/cnc1900_spi.h
--- u-boot-2011.06_original/include/cnc1900_spi.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc1900_spi.h	2015-05-29 15:18:31.577595000 +0800
@@ -0,0 +1,112 @@
+#ifndef __CNC1900_SPI_H__
+#define __CNC1900_SPI_H__
+#define SREG_BASE   	0x80150000
+
+#define rCTRLR0	    (SREG_BASE + 0x00)
+#define rCTRLR1	    (SREG_BASE + 0x04)
+#define rSSIENR	    (SREG_BASE + 0x08)
+#define rMWCR  	    (SREG_BASE + 0x0C)
+#define rSER   	    (SREG_BASE + 0x10)
+#define rBAUDR    	(SREG_BASE + 0x14)
+#define rTXFTLR 	(SREG_BASE + 0x18)
+#define rRXFTLR 	(SREG_BASE + 0x1C)
+#define rTXFLR  	(SREG_BASE + 0x20)
+#define rRXFLR  	(SREG_BASE + 0x24)
+#define rSR    		(SREG_BASE + 0x28)
+#define rIMR   		(SREG_BASE + 0x2C)
+#define rISR   		(SREG_BASE + 0x30)
+#define rRISR  		(SREG_BASE + 0x34)
+#define rTXOICR 	(SREG_BASE + 0x38)
+#define rRXOICR 	(SREG_BASE + 0x3C)
+#define rRXUICR		(SREG_BASE + 0x40)
+#define rMSTICR		(SREG_BASE + 0x44)
+#define rICR   		(SREG_BASE + 0x48)
+#define rDR    		(SREG_BASE + 0x60)
+
+#define SPI_PINMUX  (0xb211000c)
+
+#define BOOTCFG		0x80100034
+
+#define spi_write(a, v) 	(*((volatile unsigned short *)(a)) = (v))
+#define spi_read(a) 		(*((volatile unsigned short *)(a)))
+
+#define CMD_RDSR 	0x05
+#define CMD_WRSR 	0x01
+#define CMD_READ 	0x03
+#define CMD_WREN 	0x06
+#define CMD_PP 		0x02
+#define CMD_SE 		0x20
+#define CMD_BE 		0xd8
+#define CMD_CE 		0xc7
+#define CMD_RDID 	0x9f
+
+#define PP_SZ        256
+#define PP_TIME_US 	1500
+//#define FL_SEC_SZ 	0x1000
+//#define FL_BLK_SZ 	0x10000
+
+/****************************************************************************/
+
+#define SPI_DEBUG
+#ifdef SPI_DEBUG
+#define SDEBUG(args...)                     \
+	do {                                    \
+		printf(args);                       \
+	} while(0)
+#else
+#define SDEBUG(args...) do { } while(0)
+#endif
+
+/****************************************************************************/
+
+typedef enum {
+	ERASE_SEC,
+	ERASE_BLK,
+	ERASE_CHIP
+} flasherase_t;
+
+typedef enum {
+	TMOD_TXRX = 0x0,
+	TMOD_TX   = 0x1,
+	TMOD_RX   = 0x2,
+	TMOD_EE   = 0x3 } TMOD_E;
+typedef enum {
+	TIMING0   = 0,
+	TIMING1   = 1,
+	TIMING2   = 2,
+	TIMING3   = 3   } TIMING_E;
+
+typedef enum {
+	BOOT_NOR  = 0,
+	BOOT_SPI  = 1,
+	BOOT_NAND = 2   } BOOT_TYPE_E;
+
+typedef struct sflash_info {
+	char	*name;
+	u32		jedec_id;
+	u16     ext_id;
+
+	unsigned sector_size;
+	u16		n_sectors;
+
+	u16		flags;
+#define	SECT_4K		0x01
+} sfinf_t;
+
+#ifndef ARRAY_SIZE
+#define ARRAY_SIZE(x)		(sizeof(x) / sizeof((x)[0]))
+#endif
+
+/**********************************************************************************/
+
+void spi__init(void);
+
+int seeprom_read(unsigned caddr, uchar *maddr, unsigned size);
+int seeprom_write(unsigned caddr, uchar *maddr, unsigned size);
+int seeprom_erase(unsigned cmd, unsigned saddr, unsigned size);
+int seeprom_probe(void);
+
+/**********************************************************************************/
+
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/cnc_util.h u-boot-2011.06/include/cnc_util.h
--- u-boot-2011.06_original/include/cnc_util.h	1970-01-01 08:00:00.000000000 +0800
+++ u-boot-2011.06/include/cnc_util.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,129 @@
+#ifndef __CNC_UTIL_H__
+#define __CNC_UTIL_H__
+
+#include <config.h>
+#include <common.h>
+#include <command.h>
+#include <malloc.h>
+#include <image.h>
+#include <asm/byteorder.h>
+#include <usb.h>
+#include <jffs2/jffs2.h>
+#include <nand.h>
+#include <rsa_verify.h>
+#include <spi_flash.h>
+
+#define xColorBlack            "\e[1;30m"
+#define xColorRed              "\e[1;31m"
+#define xColorGreen            "\e[1;32m"
+#define xColorYellow           "\e[1;33m"
+#define xColorBlue             "\e[1;34m"
+#define xColorMagenta          "\e[1;35m"
+#define xColorCyan             "\e[1;36m"
+#define xColorWhite            "\e[1;37m"
+
+#define xColorLightBlack       "\e[0;30m"
+#define xColorLightRed         "\e[0;31m"
+#define xColorLightGreen       "\e[0;32m"
+#define xColorLightYellow      "\e[0;33m"
+#define xColorLightBlue        "\e[0;34m"
+#define xColorLightMagenta     "\e[0;35m"
+#define xColorLightCyan        "\e[0;36m"
+#define xColorLightWhite       "\e[0;37m"
+
+#define xColorNormal		   "\e[m"
+#define xBlinkOn               "\e[1;5m"
+
+typedef enum cnc_ImageType
+{
+	KERNEL=0, //preserve mkimg header.
+	RAMDISK=1, //preserve mkimg header
+	JFFS2=2,  //remove mkimg header
+	RAW=3,    //no-header (don't try to do parsing of mkimage header)
+}cnc_ImageType;
+
+#define MAXIUM_NO_OF_IMAGE     16
+#define PARTITION_NAME_LENGTH  64
+typedef struct ImagePartition_t
+{
+	char   mMtdId[16];
+	char   mPartionName[PARTITION_NAME_LENGTH];
+	UInt32 mFlashAddress;
+	UInt32 mDdrAddress;
+	UInt32 mLength;
+}ImagePartition_t;
+
+typedef struct ImagePartitionList_t
+{
+	int mNoOfPartition;
+	ImagePartition_t mImagePartitionList[MAXIUM_NO_OF_IMAGE];
+}ImagePartitionList_t;
+
+/*Public key for Secure Kernel::the declaration/definition of pkey must be adjacent to blob_pkey,
+* or else the function public_key_does_not_match_mine() will not work */
+extern unsigned char pkey[];
+
+/*Public key for Secure Blob::the declaration/definition of blob_pkey must be adjacent to pkey,
+ * or else the function public_key_does_not_match_mine() will not work */
+extern unsigned char blob_pkey[];
+extern char ColorBlack[];
+extern char ColorRed[];
+extern char ColorGreen[];
+extern char ColorYellow[];
+extern char ColorBlue[];
+extern char ColorMagenta[];
+extern char ColorCyan[];
+extern char ColorWhite[];
+extern char ColorLightBlack[];
+extern char ColorLightRed[];
+extern char ColorLightGreen[];
+extern char ColorLightYellow[];
+extern char ColorLightBlue[];
+extern char ColorLightMagenta[];
+extern char ColorLightCyan[];
+extern char ColorLightWhite[];
+extern char ColorNormal[];
+extern char BlinkOn[];
+
+void Cnc_DumpMemory(UInt32 aStartAddress, UInt32 aCount);
+
+int cnc_NorErase(UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_NorVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_NorRead(UInt32 aFlashSourceAddress, UInt32 aDdrDestinationAddress,  UInt32 aLength);
+int cnc_NorWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength);
+
+int cnc_NandErase(UInt32 aFlashStartAddress, UInt32 aLength , UInt32 aEraseSpread);
+int cnc_NandVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_NandRead(uint32_t aSrcAddressInFlash,  uint32_t aDstAddressInDram,  uint32_t alen);
+int cnc_NandWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength, cnc_ImageType aImageType );
+
+//int cnc_EMMCErase(UInt32 aFlashStartAddress, UInt32 aLength , UInt32 aEraseSpread);
+int cnc_EMMCVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_EMMCVerify2(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_EMMCRead(uint32_t aSrcAddressInFlash,  uint32_t aDstAddressInDram,  uint32_t alen);
+int cnc_EMMCWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength, cnc_ImageType aImageType );
+int cnc_EMMCWrite2(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength, cnc_ImageType aImageType );
+int cnc_CreatGPTPartitionTable(ImagePartitionList_t *pt_list);
+int cnc_EMMCRescan(void);
+
+int cnc_SpiErase(UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_SpiVerify(UInt32 aDdrStartAddress, UInt32 aFlashStartAddress, UInt32 aLength);
+int cnc_SpiRead(UInt32 aFlashSourceAddress, UInt32 aDdrDestinationAddress,  UInt32 aLength);
+int cnc_SpiWrite(UInt32 aDdrSourceAddress, UInt32 aFlashDestinationAddress, UInt32 aLength);
+
+int cnc_UsbStart(void);
+int cnc_UsbStop(void);
+int cnc_LoadFileFromUsb(const char* pFileName, UInt32 aAddress, UInt32 * apFileSize);
+int Cnc_InPlaceDecryptOnlyImage(UInt32 aSrcDstAddress, UInt32 aLength);
+int Cnc_InPlaceDecryptOnlyImage_AES(UInt8 *KeyLadder, UInt32 aSrcDstAddress, UInt32 aLength);
+int Cnc_DecryptImage(UInt32 aSourceAddress, UInt32 aDestinationAddress, UInt32 aLength);
+int Cnc_DecryptImageGetHash(UInt32 aSourceAddress, UInt32 aDestinationAddress, UInt32 aLength, UInt8* apHashBuf, int aHasBufLength);
+int Cnc_ImgHybRsa_Verify (UInt8 hash[32], UInt32 asignAddress, UInt8 *publicKey);
+unsigned int SecHWGetRSAEnable(void);
+int cnc_Read_MtdPartition(const char *apMtdID, const char* apMtdPartitionName, UInt32 aDestinationAddress, UInt32 aLength /* 0xFFFFFFFF - to read comple region */);
+int ProgramAndVerify2Spi(UInt32 aDdrAddress, UInt32 aFlashAddress, UInt32 aLength );
+int ProgramAndVerify2Nand(UInt32 aDdrAddress, UInt32 aFlashAddress, UInt32 aLength);
+int ProgramAndVerify2EMMC(UInt32 aDdrAddress, UInt32 aFlashAddress, UInt32 aLength);
+int ImgRsa_Verify (uint32_t aImgAddress, uint32_t aLen, uint32_t asignAddress, cnc_ImageType imageType);
+
+#endif
diff '--exclude=.svn' -Naur u-boot-2011.06_original/include/command.h u-boot-2011.06/include/command.h
